var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
define(["require", "exports", "system_lib/Script", "../system_lib/Metadata", "../system/SimpleFile", "../system/WebRenderer"], function (require, exports, Script_1, Metadata_1, SimpleFile_1, WebRenderer_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var Scribble = (function (_super) {
        __extends(Scribble, _super);
        function Scribble(env) {
            var _this = _super.call(this, env) || this;
            _this.kBlockPath = '/public/block/Scribble/ScribbleResult';
            _this.kWebRendererFolderPath = '/public/WebRenderer';
            _this.mPublishedTask = _this.getProperty('Realm.Scribble.group.Scribble.OnPublish.running', function () { });
            console.log('Scribble started.');
            return _this;
        }
        Scribble.prototype.finish = function (data) {
            var _this = this;
            var tempPath = data.tempPath;
            var tempSrc = "/temp/" + tempPath;
            return new Promise(function (resolve) {
                SimpleFile_1.SimpleFile.copy(tempSrc, _this.kBlockPath + "/media/scribble.png", true).then(function () {
                    SimpleFile_1.SimpleFile.read(_this.kBlockPath + "/Spec.pixi").then(function (contents) {
                        var data = JSON.parse(contents);
                        data['root']['blocks'][0]['mMedia']['mFileTime'] = +(new Date());
                        SimpleFile_1.SimpleFile.write(_this.kBlockPath + "/Spec.pixi", JSON.stringify(data)).then(function () {
                            _this.mPublishedTask.value = true;
                            _this.saveResult();
                            resolve();
                        });
                    });
                });
            });
        };
        Scribble.prototype.saveResult = function () {
            var _this = this;
            var compositeBlockUrl = "http://localhost:9080/spot/index.ftl?wsConn=1&noConn=1&transparent=1&block=Main/ScribbleOverPhotoResult";
            var now = new Date();
            var filename = now.getFullYear() + "-" + this.padZero(now.getMonth()) + "-" + this.padZero(now.getDate()) + "-" + this.padZero(now.getHours()) + this.padZero(now.getMinutes()) + ".png";
            WebRenderer_1.WebRenderer.render(compositeBlockUrl, 'temp.png', 1080, 1920, 2000, true).then(function () {
                SimpleFile_1.SimpleFile.move(_this.kWebRendererFolderPath + "/temp.png", "/public/scribble-results/" + filename, true);
            });
        };
        Scribble.prototype.padZero = function (num) {
            var numStr = num.toString();
            if (numStr.length === 1)
                return '0' + numStr;
            return numStr;
        };
        __decorate([
            Metadata_1.resource(),
            __metadata("design:type", Function),
            __metadata("design:paramtypes", [Object]),
            __metadata("design:returntype", Object)
        ], Scribble.prototype, "finish", null);
        return Scribble;
    }(Script_1.Script));
    exports.Scribble = Scribble;
});
