// modules are defined as an array
// [ module function, map of requires ]
//
// map of requires is short require name -> numeric require
//
// anything defined in a previous bundle is accessed via the
// orig method which is the require for previous bundles
parcelRequire = (function (modules, cache, entry, globalName) {
  // Save the require from previous bundle to this closure if any
  var previousRequire = typeof parcelRequire === 'function' && parcelRequire;
  var nodeRequire = typeof require === 'function' && require;

  function newRequire(name, jumped) {
    if (!cache[name]) {
      if (!modules[name]) {
        // if we cannot find the module within our internal map or
        // cache jump to the current global require ie. the last bundle
        // that was added to the page.
        var currentRequire = typeof parcelRequire === 'function' && parcelRequire;
        if (!jumped && currentRequire) {
          return currentRequire(name, true);
        }

        // If there are other bundles on this page the require from the
        // previous one is saved to 'previousRequire'. Repeat this as
        // many times as there are bundles until the module is found or
        // we exhaust the require chain.
        if (previousRequire) {
          return previousRequire(name, true);
        }

        // Try the node require function if it exists.
        if (nodeRequire && typeof name === 'string') {
          return nodeRequire(name);
        }

        var err = new Error('Cannot find module \'' + name + '\'');
        err.code = 'MODULE_NOT_FOUND';
        throw err;
      }

      localRequire.resolve = resolve;
      localRequire.cache = {};

      var module = cache[name] = new newRequire.Module(name);

      modules[name][0].call(module.exports, localRequire, module, module.exports, this);
    }

    return cache[name].exports;

    function localRequire(x){
      return newRequire(localRequire.resolve(x));
    }

    function resolve(x){
      return modules[name][1][x] || x;
    }
  }

  function Module(moduleName) {
    this.id = moduleName;
    this.bundle = newRequire;
    this.exports = {};
  }

  newRequire.isParcelRequire = true;
  newRequire.Module = Module;
  newRequire.modules = modules;
  newRequire.cache = cache;
  newRequire.parent = previousRequire;
  newRequire.register = function (id, exports) {
    modules[id] = [function (require, module) {
      module.exports = exports;
    }, {}];
  };

  var error;
  for (var i = 0; i < entry.length; i++) {
    try {
      newRequire(entry[i]);
    } catch (e) {
      // Save first error but execute all entries
      if (!error) {
        error = e;
      }
    }
  }

  if (entry.length) {
    // Expose entry point to Node, AMD or browser globals
    // Based on https://github.com/ForbesLindesay/umd/blob/master/template.js
    var mainExports = newRequire(entry[entry.length - 1]);

    // CommonJS
    if (typeof exports === "object" && typeof module !== "undefined") {
      module.exports = mainExports;

    // RequireJS
    } else if (typeof define === "function" && define.amd) {
     define(function () {
       return mainExports;
     });

    // <script>
    } else if (globalName) {
      this[globalName] = mainExports;
    }
  }

  // Override the current require with this new one
  parcelRequire = newRequire;

  if (error) {
    // throw error from earlier, _after updating parcelRequire_
    throw error;
  }

  return newRequire;
})({"app/signaturePad/point.ts":[function(require,module,exports) {
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Point = void 0;

var Point =
/** @class */
function () {
  function Point(x, y, time) {
    this.x = x;
    this.y = y;
    this.time = time || Date.now();
  }

  Point.prototype.distanceTo = function (start) {
    return Math.sqrt(Math.pow(this.x - start.x, 2) + Math.pow(this.y - start.y, 2));
  };

  Point.prototype.equals = function (other) {
    return this.x === other.x && this.y === other.y && this.time === other.time;
  };

  Point.prototype.velocityFrom = function (start) {
    return this.time !== start.time ? this.distanceTo(start) / (this.time - start.time) : 0;
  };

  return Point;
}();

exports.Point = Point;
},{}],"app/signaturePad/bezier.ts":[function(require,module,exports) {
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Bezier = void 0;

var _point = require("./point");

var Bezier =
/** @class */
function () {
  function Bezier(startPoint, control2, control1, endPoint, startWidth, endWidth) {
    this.startPoint = startPoint;
    this.control2 = control2;
    this.control1 = control1;
    this.endPoint = endPoint;
    this.startWidth = startWidth;
    this.endWidth = endWidth;
  }

  Bezier.fromPoints = function (points, widths) {
    var c2 = this.calculateControlPoints(points[0], points[1], points[2]).c2;
    var c3 = this.calculateControlPoints(points[1], points[2], points[3]).c1;
    return new Bezier(points[1], c2, c3, points[2], widths.start, widths.end);
  };

  Bezier.calculateControlPoints = function (s1, s2, s3) {
    var dx1 = s1.x - s2.x;
    var dy1 = s1.y - s2.y;
    var dx2 = s2.x - s3.x;
    var dy2 = s2.y - s3.y;
    var m1 = {
      x: (s1.x + s2.x) / 2.0,
      y: (s1.y + s2.y) / 2.0
    };
    var m2 = {
      x: (s2.x + s3.x) / 2.0,
      y: (s2.y + s3.y) / 2.0
    };
    var l1 = Math.sqrt(dx1 * dx1 + dy1 * dy1);
    var l2 = Math.sqrt(dx2 * dx2 + dy2 * dy2);
    var dxm = m1.x - m2.x;
    var dym = m1.y - m2.y;
    var k = l2 / (l1 + l2);
    var cm = {
      x: m2.x + dxm * k,
      y: m2.y + dym * k
    };
    var tx = s2.x - cm.x;
    var ty = s2.y - cm.y;
    return {
      c1: new _point.Point(m1.x + tx, m1.y + ty),
      c2: new _point.Point(m2.x + tx, m2.y + ty)
    };
  }; // Returns approximated length. Code taken from https://www.lemoda.net/maths/bezier-length/index.html.


  Bezier.prototype.length = function () {
    var steps = 10;
    var length = 0;
    var px;
    var py;

    for (var i = 0; i <= steps; i += 1) {
      var t = i / steps;
      var cx = this.point(t, this.startPoint.x, this.control1.x, this.control2.x, this.endPoint.x);
      var cy = this.point(t, this.startPoint.y, this.control1.y, this.control2.y, this.endPoint.y);

      if (i > 0) {
        var xdiff = cx - px;
        var ydiff = cy - py;
        length += Math.sqrt(xdiff * xdiff + ydiff * ydiff);
      }

      px = cx;
      py = cy;
    }

    return length;
  }; // Calculate parametric value of x or y given t and the four point coordinates of a cubic bezier curve.


  Bezier.prototype.point = function (t, start, c1, c2, end) {
    return start * (1.0 - t) * (1.0 - t) * (1.0 - t) + 3.0 * c1 * (1.0 - t) * (1.0 - t) * t + 3.0 * c2 * (1.0 - t) * t * t + end * t * t * t;
  };

  return Bezier;
}();

exports.Bezier = Bezier;
},{"./point":"app/signaturePad/point.ts"}],"app/signaturePad/throttle.ts":[function(require,module,exports) {
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.throttle = throttle;

// Slightly simplified version of http://stackoverflow.com/a/27078401/815507
function throttle(fn, wait) {
  if (wait === void 0) {
    wait = 250;
  }

  var previous = 0;
  var timeout = null;
  var result;
  var storedContext;
  var storedArgs;

  var later = function later() {
    previous = Date.now();
    timeout = null;
    result = fn.apply(storedContext, storedArgs);

    if (!timeout) {
      storedContext = null;
      storedArgs = [];
    }
  };

  return function () {
    var args = [];

    for (var _i = 0; _i < arguments.length; _i++) {
      args[_i] = arguments[_i];
    }

    var now = Date.now();
    var remaining = wait - (now - previous);
    storedContext = this;
    storedArgs = args;

    if (remaining <= 0 || remaining > wait) {
      if (timeout) {
        clearTimeout(timeout);
        timeout = null;
      }

      previous = now;
      result = fn.apply(storedContext, storedArgs);

      if (!timeout) {
        storedContext = null;
        storedArgs = [];
      }
    } else if (!timeout) {
      timeout = window.setTimeout(later, remaining);
    }

    return result;
  };
}
},{}],"app/signaturePad/signature_pad.ts":[function(require,module,exports) {
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _bezier = require("./bezier");

var _point = require("./point");

var _throttle = require("./throttle");

/**
 * The main idea and some parts of the code (e.g. drawing variable width Bézier curve) are taken from:
 * http://corner.squareup.com/2012/07/smoother-signatures.html
 *
 * Implementation of interpolation using cubic Bézier curves is taken from:
 * http://www.benknowscode.com/2012/09/path-interpolation-using-cubic-bezier_9742.html
 *
 * Algorithm for approximated length of a Bézier curve is taken from:
 * http://www.lemoda.net/maths/bezier-length/index.html
 */
var SignaturePad =
/** @class */
function () {
  function SignaturePad(canvas, options) {
    if (options === void 0) {
      options = {};
    }

    var _this = this;

    this.canvas = canvas; // Event handlers

    this._handleMouseDown = function (event) {
      if (event.which === 1) {
        _this._mouseButtonDown = true;

        _this._strokeBegin(event);
      }
    };

    this._handleMouseMove = function (event) {
      if (_this._mouseButtonDown) {
        _this._strokeMoveUpdate(event);
      }
    };

    this._handleMouseUp = function (event) {
      if (event.which === 1 && _this._mouseButtonDown) {
        _this._mouseButtonDown = false;

        _this._strokeEnd(event);
      }
    };

    this._handleTouchStart = function (event) {
      // Prevent scrolling.
      event.preventDefault();

      if (event.targetTouches.length === 1) {
        var touch = event.changedTouches[0];

        _this._strokeBegin(touch);
      }
    };

    this._handleTouchMove = function (event) {
      // Prevent scrolling.
      event.preventDefault();
      var touch = event.targetTouches[0];

      _this._strokeMoveUpdate(touch);
    };

    this._handleTouchEnd = function (event) {
      var wasCanvasTouched = event.target === _this.canvas;

      if (wasCanvasTouched) {
        event.preventDefault();
        var touch = event.changedTouches[0];

        _this._strokeEnd(touch);
      }
    };

    this.velocityFilterWeight = options.velocityFilterWeight || 0.7;
    this.minWidth = options.minWidth || 0.5;
    this.maxWidth = options.maxWidth || 2.5;
    this.throttle = 'throttle' in options ? options.throttle : 16; // in milisecondss

    this.minDistance = 'minDistance' in options ? options.minDistance : 5; // in pixels

    if (this.throttle) {
      this._strokeMoveUpdate = (0, _throttle.throttle)(SignaturePad.prototype._strokeUpdate, this.throttle);
    } else {
      this._strokeMoveUpdate = SignaturePad.prototype._strokeUpdate;
    }

    this.dotSize = options.dotSize || function () {
      return (this.minWidth + this.maxWidth) / 2;
    };

    this.penColor = options.penColor || 'black';
    this.backgroundColor = options.backgroundColor || 'rgba(0,0,0,0)';
    this.onBegin = options.onBegin;
    this.onEnd = options.onEnd;
    this._ctx = canvas.getContext('2d');
    this.clear(); // Enable mouse and touch event handlers

    this.on();
  }

  SignaturePad.prototype.clear = function () {
    var ctx = this._ctx;
    var canvas = this.canvas; // Clear canvas using background color

    ctx.fillStyle = this.backgroundColor;
    ctx.clearRect(0, 0, canvas.width, canvas.height);
    ctx.fillRect(0, 0, canvas.width, canvas.height);
    this._data = [];

    this._reset();

    this._isEmpty = true;
  };

  SignaturePad.prototype.fromDataURL = function (dataUrl, options, callback) {
    var _this = this;

    if (options === void 0) {
      options = {};
    }

    var image = new Image();
    var ratio = options.ratio || window.devicePixelRatio || 1;
    var width = options.width || this.canvas.width / ratio;
    var height = options.height || this.canvas.height / ratio;

    this._reset();

    image.onload = function () {
      _this._ctx.drawImage(image, 0, 0, width, height);

      if (callback) {
        callback();
      }
    };

    image.onerror = function (error) {
      if (callback) {
        callback(error);
      }
    };

    image.src = dataUrl;
    this._isEmpty = false;
  };

  SignaturePad.prototype.toDataURL = function (type, encoderOptions) {
    if (type === void 0) {
      type = 'image/png';
    }

    switch (type) {
      case 'image/svg+xml':
        return this._toSVG();

      default:
        return this.canvas.toDataURL(type, encoderOptions);
    }
  };

  SignaturePad.prototype.on = function () {
    // Disable panning/zooming when touching canvas element
    this.canvas.style.touchAction = 'none';
    this.canvas.style.msTouchAction = 'none';

    if (window.PointerEvent) {
      this._handlePointerEvents();
    } else {
      this._handleMouseEvents();

      if ('ontouchstart' in window) {
        this._handleTouchEvents();
      }
    }
  };

  SignaturePad.prototype.off = function () {
    // Enable panning/zooming when touching canvas element
    this.canvas.style.touchAction = 'auto';
    this.canvas.style.msTouchAction = 'auto';
    this.canvas.removeEventListener('pointerdown', this._handleMouseDown);
    this.canvas.removeEventListener('pointermove', this._handleMouseMove);
    document.removeEventListener('pointerup', this._handleMouseUp);
    this.canvas.removeEventListener('mousedown', this._handleMouseDown);
    this.canvas.removeEventListener('mousemove', this._handleMouseMove);
    document.removeEventListener('mouseup', this._handleMouseUp);
    this.canvas.removeEventListener('touchstart', this._handleTouchStart);
    this.canvas.removeEventListener('touchmove', this._handleTouchMove);
    this.canvas.removeEventListener('touchend', this._handleTouchEnd);
  };

  SignaturePad.prototype.isEmpty = function () {
    return this._isEmpty;
  };

  SignaturePad.prototype.fromData = function (pointGroups) {
    var _this = this;

    this.clear();

    this._fromData(pointGroups, function (_a) {
      var color = _a.color,
          curve = _a.curve;
      return _this._drawCurve({
        color: color,
        curve: curve
      });
    }, function (_a) {
      var color = _a.color,
          point = _a.point;
      return _this._drawDot({
        color: color,
        point: point
      });
    });

    this._data = pointGroups;
  };

  SignaturePad.prototype.toData = function () {
    return this._data;
  }; // Private methods


  SignaturePad.prototype._strokeBegin = function (event) {
    // // Select white color if touch radius is bigger than 5,
    // // user is probably using it's finger.
    // const touchRadius = event['radiusX'] | 0;
    // const color: string = touchRadius > 5 ? 'white' : this.penColor;
    // console.log(color);
    var newPointGroup = {
      color: this.penColor,
      points: []
    };

    this._data.push(newPointGroup);

    this._reset();

    this._strokeUpdate(event);

    if (typeof this.onBegin === 'function') {
      this.onBegin(event);
    }
  };

  SignaturePad.prototype._strokeUpdate = function (event) {
    var x = event.clientX;
    var y = event.clientY;

    var point = this._createPoint(x, y);

    var lastPointGroup = this._data[this._data.length - 1];
    var lastPoints = lastPointGroup.points;
    var lastPoint = lastPoints.length > 0 && lastPoints[lastPoints.length - 1];
    var isLastPointTooClose = lastPoint ? point.distanceTo(lastPoint) <= this.minDistance : false;
    var color = lastPointGroup.color; // Skip this point if it's too close to the previous one

    if (!lastPoint || !(lastPoint && isLastPointTooClose)) {
      var curve = this._addPoint(point, event);

      if (!lastPoint) {
        this._drawDot({
          color: color,
          point: point
        });
      } else if (curve) {
        this._drawCurve({
          color: color,
          curve: curve
        });
      }

      lastPoints.push({
        time: point.time,
        x: point.x,
        y: point.y
      });
    }
  };

  SignaturePad.prototype._strokeEnd = function (event) {
    this._strokeUpdate(event);

    if (typeof this.onEnd === 'function') {
      this.onEnd(event);
    }
  };

  SignaturePad.prototype._handlePointerEvents = function () {
    this._mouseButtonDown = false;
    this.canvas.addEventListener('pointerdown', this._handleMouseDown);
    this.canvas.addEventListener('pointermove', this._handleMouseMove);
    document.addEventListener('pointerup', this._handleMouseUp);
  };

  SignaturePad.prototype._handleMouseEvents = function () {
    this._mouseButtonDown = false;
    this.canvas.addEventListener('mousedown', this._handleMouseDown);
    this.canvas.addEventListener('mousemove', this._handleMouseMove);
    document.addEventListener('mouseup', this._handleMouseUp);
  };

  SignaturePad.prototype._handleTouchEvents = function () {
    this.canvas.addEventListener('touchstart', this._handleTouchStart);
    this.canvas.addEventListener('touchmove', this._handleTouchMove);
    this.canvas.addEventListener('touchend', this._handleTouchEnd);
  }; // Called when a new line is started


  SignaturePad.prototype._reset = function () {
    this._lastPoints = [];
    this._lastVelocity = 0;
    this._lastWidth = (this.minWidth + this.maxWidth) / 2;
    this._ctx.fillStyle = this.penColor;
  };

  SignaturePad.prototype._createPoint = function (x, y) {
    var rect = this.canvas.getBoundingClientRect();
    return new _point.Point(x - rect.left, y - rect.top, new Date().getTime());
  }; // Add point to _lastPoints array and generate a new curve if there are enough points (i.e. 3)


  SignaturePad.prototype._addPoint = function (point, event) {
    var _lastPoints = this._lastPoints;

    _lastPoints.push(point);

    if (_lastPoints.length > 2) {
      // To reduce the initial lag make it work with 3 points
      // by copying the first point to the beginning.
      if (_lastPoints.length === 3) {
        _lastPoints.unshift(_lastPoints[0]);
      } // _points array will always have 4 points here.


      var widths = this._calculateCurveWidths(_lastPoints[1], _lastPoints[2], event);

      var curve = _bezier.Bezier.fromPoints(_lastPoints, widths); // Remove the first element from the list, so that there are no more than 4 points at any time.


      _lastPoints.shift();

      return curve;
    }

    return null;
  };

  SignaturePad.prototype._calculateCurveWidths = function (startPoint, endPoint, event) {
    var velocity = this.velocityFilterWeight * endPoint.velocityFrom(startPoint) + (1 - this.velocityFilterWeight) * this._lastVelocity;

    var pressure = event ? event['force'] || 0 : 0;

    var newWidth = this._strokeWidth(velocity, pressure);

    var widths = {
      end: newWidth,
      start: this._lastWidth
    };
    this._lastVelocity = velocity;
    this._lastWidth = newWidth;
    return widths;
  };

  SignaturePad.prototype._strokeWidth = function (velocity, pressure) {
    return Math.max(this.maxWidth / (velocity + 1) + pressure * 10, this.minWidth);
  };
  /**
  * Draws a rounded rectangle using the current state of the canvas.
  * If you omit the last three params, it will draw a rectangle
  * outline with a 5 pixel border radius
  * @param {CanvasRenderingContext2D} ctx
  * @param {Number} x The top left x coordinate
  * @param {Number} y The top left y coordinate
  * @param {Number} width The width of the rectangle
  * @param {Number} height The height of the rectangle
  * @param {Number} [radius = 5] The corner radius; It can also be an object
  *                 to specify different radii for corners
  * @param {Number} [radius.tl = 0] Top left
  * @param {Number} [radius.tr = 0] Top right
  * @param {Number} [radius.br = 0] Bottom right
  * @param {Number} [radius.bl = 0] Bottom left
  * @param {Boolean} [fill = false] Whether to fill the rectangle.
  * @param {Boolean} [stroke = true] Whether to stroke the rectangle.
   https://stackoverflow.com/questions/1255512/how-to-draw-a-rounded-rectangle-on-html-canvas
   */
  //  private roundRect(
  // 	 ctx: CanvasRenderingContext2D,
  // 	 x: number, y: number,
  // 	 width: number, height: number, radius: number|any,
  // 	 fill?: boolean, stroke?: boolean
  //  ) {
  //   if (typeof stroke == 'undefined') {
  //     stroke = true;
  //   }
  //   if (typeof radius === 'undefined') {
  //     radius = 5;
  //   }
  //   if (typeof radius === 'number') {
  //     radius = {tl: radius, tr: radius, br: radius, bl: radius};
  //   } else {
  //     var defaultRadius = {tl: 0, tr: 0, br: 0, bl: 0};
  //     for (var side in defaultRadius) {
  //       radius[side] = radius[side] || defaultRadius[side];
  //     }
  //   }
  //   ctx.beginPath();
  //   ctx.moveTo(x + radius.tl, y);
  //   ctx.lineTo(x + width - radius.tr, y);
  //   ctx.quadraticCurveTo(x + width, y, x + width, y + radius.tr);
  //   ctx.lineTo(x + width, y + height - radius.br);
  //   ctx.quadraticCurveTo(x + width, y + height, x + width - radius.br, y + height);
  //   ctx.lineTo(x + radius.bl, y + height);
  //   ctx.quadraticCurveTo(x, y + height, x, y + height - radius.bl);
  //   ctx.lineTo(x, y + radius.tl);
  //   ctx.quadraticCurveTo(x, y, x + radius.tl, y);
  //   ctx.closePath();
  //   if (fill) {
  //     ctx.fill();
  //   }
  //   if (stroke) {
  //     ctx.stroke();
  //   }
  // }


  SignaturePad.prototype._drawCurveSegment = function (x, y, size) {
    var ctx = this._ctx; // Draw circle

    ctx.moveTo(x, y);
    ctx.arc(x, y, size, 0, 2 * Math.PI, false); // Draw square
    // let height = size*5;
    // this.roundRect(ctx, x - size/2, y - height/2, size, height, 3);
    // ctx.rect(x - size/2, y - height/2, size, size);

    this._isEmpty = false;
  };

  SignaturePad.prototype._drawCurve = function (_a) {
    var color = _a.color,
        curve = _a.curve;
    var ctx = this._ctx;
    var widthDelta = curve.endWidth - curve.startWidth; // '2' is just an arbitrary number here. If only lenght is used, then
    // there are gaps between curve segments :/

    var drawSteps = Math.floor(curve.length()) * 2;
    ctx.beginPath();
    ctx.fillStyle = color;

    for (var i = 0; i < drawSteps; i += 1) {
      // Calculate the Bezier (x, y) coordinate for this step.
      var t = i / drawSteps;
      var tt = t * t;
      var ttt = tt * t;
      var u = 1 - t;
      var uu = u * u;
      var uuu = uu * u;
      var x = uuu * curve.startPoint.x;
      x += 3 * uu * t * curve.control1.x;
      x += 3 * u * tt * curve.control2.x;
      x += ttt * curve.endPoint.x;
      var y = uuu * curve.startPoint.y;
      y += 3 * uu * t * curve.control1.y;
      y += 3 * u * tt * curve.control2.y;
      y += ttt * curve.endPoint.y;
      var width = curve.startWidth + ttt * widthDelta;

      this._drawCurveSegment(x, y, width);
    }

    ctx.closePath();
    ctx.fill();
  };

  SignaturePad.prototype._drawDot = function (_a) {
    var color = _a.color,
        point = _a.point;
    var ctx = this._ctx;
    var width = typeof this.dotSize === 'function' ? this.dotSize() : this.dotSize;
    ctx.beginPath();

    this._drawCurveSegment(point.x, point.y, width);

    ctx.closePath();
    ctx.fillStyle = color;
    ctx.fill();
  };

  SignaturePad.prototype._fromData = function (pointGroups, drawCurve, drawDot) {
    for (var _i = 0, pointGroups_1 = pointGroups; _i < pointGroups_1.length; _i++) {
      var group = pointGroups_1[_i];
      var color = group.color,
          points = group.points;

      if (points.length > 1) {
        for (var j = 0; j < points.length; j += 1) {
          var basicPoint = points[j];
          var point = new _point.Point(basicPoint.x, basicPoint.y, basicPoint.time); // All points in the group have the same color, so it's enough to set
          // penColor just at the beginning.

          this.penColor = color;

          if (j === 0) {
            this._reset();
          }

          var curve = this._addPoint(point);

          if (curve) {
            drawCurve({
              color: color,
              curve: curve
            });
          }
        }
      } else {
        this._reset();

        drawDot({
          color: color,
          point: points[0]
        });
      }
    }
  };

  SignaturePad.prototype._toSVG = function () {
    var _this = this;

    var pointGroups = this._data;
    var ratio = Math.max(window.devicePixelRatio || 1, 1);
    var minX = 0;
    var minY = 0;
    var maxX = this.canvas.width / ratio;
    var maxY = this.canvas.height / ratio;
    var svg = document.createElementNS('http://www.w3.org/2000/svg', 'svg');
    svg.setAttribute('width', this.canvas.width.toString());
    svg.setAttribute('height', this.canvas.height.toString());

    this._fromData(pointGroups, function (_a) {
      var color = _a.color,
          curve = _a.curve;
      var path = document.createElement('path'); // Need to check curve for NaN values, these pop up when drawing
      // lines on the canvas that are not continuous. E.g. Sharp corners
      // or stopping mid-stroke and than continuing without lifting mouse.

      /* eslint-disable no-restricted-globals */

      if (!isNaN(curve.control1.x) && !isNaN(curve.control1.y) && !isNaN(curve.control2.x) && !isNaN(curve.control2.y)) {
        var attr = "M " + curve.startPoint.x.toFixed(3) + "," + curve.startPoint.y.toFixed(3) + " " + ("C " + curve.control1.x.toFixed(3) + "," + curve.control1.y.toFixed(3) + " ") + (curve.control2.x.toFixed(3) + "," + curve.control2.y.toFixed(3) + " ") + (curve.endPoint.x.toFixed(3) + "," + curve.endPoint.y.toFixed(3));
        path.setAttribute('d', attr);
        path.setAttribute('stroke-width', (curve.endWidth * 2.25).toFixed(3));
        path.setAttribute('stroke', color);
        path.setAttribute('fill', 'none');
        path.setAttribute('stroke-linecap', 'round');
        svg.appendChild(path);
      }
      /* eslint-enable no-restricted-globals */

    }, function (_a) {
      var color = _a.color,
          point = _a.point;
      var circle = document.createElement('circle');
      var dotSize = typeof _this.dotSize === 'function' ? _this.dotSize() : _this.dotSize;
      circle.setAttribute('r', dotSize.toString());
      circle.setAttribute('cx', point.x.toString());
      circle.setAttribute('cy', point.y.toString());
      circle.setAttribute('fill', color);
      svg.appendChild(circle);
    });

    var prefix = 'data:image/svg+xml;base64,';
    var header = '<svg' + ' xmlns="http://www.w3.org/2000/svg"' + ' xmlns:xlink="http://www.w3.org/1999/xlink"' + (" viewBox=\"" + minX + " " + minY + " " + maxX + " " + maxY + "\"") + (" width=\"" + maxX + "\"") + (" height=\"" + maxY + "\"") + '>';
    var body = svg.innerHTML; // IE hack for missing innerHTML property on SVGElement

    if (body === undefined) {
      var dummy = document.createElement('dummy');
      var nodes = svg.childNodes;
      dummy.innerHTML = ''; // tslint:disable-next-line: prefer-for-of

      for (var i = 0; i < nodes.length; i += 1) {
        dummy.appendChild(nodes[i].cloneNode(true));
      }

      body = dummy.innerHTML;
    }

    var footer = '</svg>';
    var data = header + body + footer;
    return prefix + btoa(data);
  };

  return SignaturePad;
}();

var _default = SignaturePad;
exports.default = _default;
},{"./bezier":"app/signaturePad/bezier.ts","./point":"app/signaturePad/point.ts","./throttle":"app/signaturePad/throttle.ts"}],"app/pixi-signature-pad.ts":[function(require,module,exports) {
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PixiSignaturePad = void 0;

var _signature_pad = _interopRequireDefault(require("./signaturePad/signature_pad"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var __awaiter = void 0 && (void 0).__awaiter || function (thisArg, _arguments, P, generator) {
  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : new P(function (resolve) {
        resolve(result.value);
      }).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

var __generator = void 0 && (void 0).__generator || function (thisArg, body) {
  var _ = {
    label: 0,
    sent: function sent() {
      if (t[0] & 1) throw t[1];
      return t[1];
    },
    trys: [],
    ops: []
  },
      f,
      y,
      t,
      g;
  return g = {
    next: verb(0),
    "throw": verb(1),
    "return": verb(2)
  }, typeof Symbol === "function" && (g[Symbol.iterator] = function () {
    return this;
  }), g;

  function verb(n) {
    return function (v) {
      return step([n, v]);
    };
  }

  function step(op) {
    if (f) throw new TypeError("Generator is already executing.");

    while (_) {
      try {
        if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
        if (y = 0, t) op = [op[0] & 2, t.value];

        switch (op[0]) {
          case 0:
          case 1:
            t = op;
            break;

          case 4:
            _.label++;
            return {
              value: op[1],
              done: false
            };

          case 5:
            _.label++;
            y = op[1];
            op = [0];
            continue;

          case 7:
            op = _.ops.pop();

            _.trys.pop();

            continue;

          default:
            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
              _ = 0;
              continue;
            }

            if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
              _.label = op[1];
              break;
            }

            if (op[0] === 6 && _.label < t[1]) {
              _.label = t[1];
              t = op;
              break;
            }

            if (t && _.label < t[2]) {
              _.label = t[2];

              _.ops.push(op);

              break;
            }

            if (t[2]) _.ops.pop();

            _.trys.pop();

            continue;
        }

        op = body.call(thisArg, _);
      } catch (e) {
        op = [6, e];
        y = 0;
      } finally {
        f = t = 0;
      }
    }

    if (op[0] & 5) throw op[1];
    return {
      value: op[0] ? op[1] : void 0,
      done: true
    };
  }
};

var PixiSignaturePad =
/** @class */
function () {
  function PixiSignaturePad(signaturePadConfig) {
    if (signaturePadConfig === void 0) {
      signaturePadConfig = {
        minWidth: 12,
        maxWidth: 12,
        color: '#FFFFFF',
        backgroundColor: 'rgba(0, 0, 0, 0)'
      };
    }

    this.signaturePadConfig = signaturePadConfig;
    this.canvas = document.querySelector("#canvas");
    this.canvasContext = this.canvas.getContext("2d");
    this.actions = document.querySelector('#main .actions');
    this.clearButton = document.querySelector('.button.clear');
    this.doneButton = document.querySelector('.button.done');
    this.signaturePad = new _signature_pad.default(this.canvas, {
      minWidth: this.signaturePadConfig.minWidth,
      maxWidth: this.signaturePadConfig.maxWidth,
      penColor: this.signaturePadConfig.color,
      backgroundColor: this.signaturePadConfig.backgroundColor,
      onEnd: this.firstLineDraw.bind(this),
      dotSize: 12 // When using pen, go with 1

    });
    this.clearButton.addEventListener('click', this.clear.bind(this));
    this.doneButton.addEventListener('click', this.allDone.bind(this));
    this.init();
  }

  PixiSignaturePad.prototype.firstLineDraw = function () {
    this.actions.classList.remove('disabled');
  };

  PixiSignaturePad.prototype.enterWriteMode = function () {
    this.canvasContext.globalCompositeOperation = 'source-over';
    this.signaturePad.minWidth = this.signaturePadConfig.minWidth;
    this.signaturePad.maxWidth = this.signaturePadConfig.maxWidth;
  };

  PixiSignaturePad.prototype.clear = function () {
    this.signaturePad.clear();
    this.actions.classList.add('disabled');
    this.enterWriteMode();
  };

  PixiSignaturePad.prototype.allDone = function () {
    return __awaiter(this, void 0, void 0, function () {
      var resultCanvas, resultContext;

      var _this = this;

      return __generator(this, function (_a) {
        switch (_a.label) {
          case 0:
            this.actions.classList.add('disabled');
            resultCanvas = document.createElement('canvas');
            resultCanvas.width = 1080;
            resultCanvas.height = 1920;
            resultContext = resultCanvas.getContext('2d');
            return [4
            /*yield*/
            , this.renderSignatureToCanvas(resultContext)];

          case 1:
            _a.sent();

            resultCanvas.toBlob(function (file) {
              var formData = new FormData();
              formData.append("file", file);
              formData.append("target", "upload");
              formData.append("fileName", "*.png");
              var xhr = new XMLHttpRequest();

              xhr.onreadystatechange = function () {
                if (xhr.readyState === 4 && xhr.status === 200) {
                  var tempPath = xhr.responseText;
                  xhr = new XMLHttpRequest();

                  xhr.onreadystatechange = function () {
                    if (xhr.readyState === 4 && xhr.status === 200) {
                      _this.clear();
                    }
                  };

                  xhr.open("POST", "/rest/script/invoke/Scribble/finish");
                  xhr.setRequestHeader('Content-Type', 'application/json');
                  xhr.send(JSON.stringify({
                    tempPath: tempPath
                  }));
                }
              };

              xhr.open("POST", "/rest/upload/multipart");
              xhr.send(formData);
            }, 'image/png', 1);
            return [2
            /*return*/
            ];
        }
      });
    });
  };
  /**
   * Renders the signature onto the result canvas.
   */


  PixiSignaturePad.prototype.renderSignatureToCanvas = function (context) {
    var _this = this;

    return new Promise(function (resolve) {
      var signatureDataURL = _this.signaturePad.toDataURL();

      var imageEl = new Image();
      imageEl.width = _this.canvas.width;
      imageEl.height = _this.canvas.height;
      imageEl.addEventListener('load', function () {
        context.drawImage(imageEl, 0, 0, imageEl.width, imageEl.height, 0, 0, 1080, 1920);
        resolve();
      });
      imageEl.src = signatureDataURL;
    });
  };

  PixiSignaturePad.prototype.init = function () {
    var canvas = this.canvas;
    var canvasContext = this.canvasContext;
    var ratio = Math.max(window.devicePixelRatio || 1, 1);
    canvas.width = canvas.offsetWidth * ratio;
    canvas.height = canvas.offsetHeight * ratio;
    canvasContext.scale(ratio, ratio);
    this.clear();
    this.actions.classList.add('disabled');
  };

  return PixiSignaturePad;
}();

exports.PixiSignaturePad = PixiSignaturePad;
},{"./signaturePad/signature_pad":"app/signaturePad/signature_pad.ts"}],"index.ts":[function(require,module,exports) {
"use strict";

var _pixiSignaturePad = require("./app/pixi-signature-pad");

new _pixiSignaturePad.PixiSignaturePad();
},{"./app/pixi-signature-pad":"app/pixi-signature-pad.ts"}]},{},["index.ts"], null)
//# sourceMappingURL=/src.77de5100.js.map