var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import SignaturePad from "./signaturePad/signature_pad";
var PixiSignaturePad = /** @class */ (function () {
    function PixiSignaturePad(signaturePadConfig) {
        if (signaturePadConfig === void 0) { signaturePadConfig = {
            minWidth: 12,
            maxWidth: 12,
            color: '#FFFFFF',
            backgroundColor: 'rgba(0, 0, 0, 0)'
        }; }
        this.signaturePadConfig = signaturePadConfig;
        this.canvas = document.querySelector("#canvas");
        this.canvasContext = this.canvas.getContext("2d");
        this.actions = document.querySelector('#main .actions');
        this.clearButton = document.querySelector('.button.clear');
        this.doneButton = document.querySelector('.button.done');
        this.signaturePad = new SignaturePad(this.canvas, {
            minWidth: this.signaturePadConfig.minWidth,
            maxWidth: this.signaturePadConfig.maxWidth,
            penColor: this.signaturePadConfig.color,
            backgroundColor: this.signaturePadConfig.backgroundColor,
            onEnd: this.firstLineDraw.bind(this),
            dotSize: 12 // When using pen, go with 1
        });
        this.clearButton.addEventListener('pointerup', this.clear.bind(this));
        this.doneButton.addEventListener('pointerup', this.allDone.bind(this));
        this.init();
    }
    PixiSignaturePad.prototype.firstLineDraw = function () {
        this.actions.classList.remove('disabled');
    };
    PixiSignaturePad.prototype.enterWriteMode = function () {
        this.canvasContext.globalCompositeOperation = 'source-over';
        this.signaturePad.minWidth = this.signaturePadConfig.minWidth;
        this.signaturePad.maxWidth = this.signaturePadConfig.maxWidth;
    };
    PixiSignaturePad.prototype.clear = function () {
        this.signaturePad.clear();
        this.actions.classList.add('disabled');
        this.enterWriteMode();
    };
    PixiSignaturePad.prototype.allDone = function () {
        return __awaiter(this, void 0, void 0, function () {
            var resultCanvas, resultContext;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.actions.classList.remove('disabled');
                        resultCanvas = document.createElement('canvas');
                        resultCanvas.width = 1080;
                        resultCanvas.height = 1920;
                        resultContext = resultCanvas.getContext('2d');
                        return [4 /*yield*/, this.renderSignatureToCanvas(resultContext)];
                    case 1:
                        _a.sent();
                        resultCanvas.toBlob(function (file) {
                            var formData = new FormData();
                            formData.append("file", file);
                            formData.append("target", "upload");
                            formData.append("fileName", "*.png");
                            var xhr = new XMLHttpRequest();
                            xhr.onreadystatechange = function () {
                                if (xhr.readyState === 4 && xhr.status === 200) {
                                    var tempPath = xhr.responseText;
                                    xhr = new XMLHttpRequest();
                                    xhr.onreadystatechange = function () {
                                        if (xhr.readyState === 4 && xhr.status === 200) {
                                            _this.clear();
                                        }
                                    };
                                    xhr.open("POST", "/rest/script/invoke/Scribble/finish");
                                    xhr.setRequestHeader('Content-Type', 'application/json');
                                    xhr.send(JSON.stringify({
                                        tempPath: tempPath
                                    }));
                                }
                            };
                            xhr.open("POST", "/rest/upload/multipart");
                            xhr.send(formData);
                        }, 'image/png', 1);
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Renders the signature onto the result canvas.
     */
    PixiSignaturePad.prototype.renderSignatureToCanvas = function (context) {
        var _this = this;
        return new Promise(function (resolve) {
            var signatureDataURL = _this.signaturePad.toDataURL();
            var imageEl = new Image();
            imageEl.width = _this.canvas.width;
            imageEl.height = _this.canvas.height;
            imageEl.addEventListener('load', function () {
                context.drawImage(imageEl, 0, 0, imageEl.width, imageEl.height, 0, 0, 1080, 1920);
                resolve();
            });
            imageEl.src = signatureDataURL;
        });
    };
    PixiSignaturePad.prototype.init = function () {
        var canvas = this.canvas;
        var canvasContext = this.canvasContext;
        var ratio = Math.max(window.devicePixelRatio || 1, 1);
        canvas.width = canvas.offsetWidth * ratio;
        canvas.height = canvas.offsetHeight * ratio;
        canvasContext.scale(ratio, ratio);
        this.clear();
        this.actions.classList.add('disabled');
    };
    return PixiSignaturePad;
}());
export { PixiSignaturePad };
//# sourceMappingURL=pixi-signature-pad.js.map